#include <stdio.h>
#include <stdlib.h>

typedef struct {
	char c;
	int n;
	double d;
} SomeNumbers;

SomeNumbers init_struct(char c, int n, double d) {
	SomeNumbers numbers;
	numbers.c = c;
	numbers.n = n;
	numbers.d = d;
	return numbers;
}

SomeNumbers init_any_order(char c, int n, double d) {
	SomeNumbers numbers = { .d = d, .n = n, .c = c };
	return numbers;
}

void print_numbers(SomeNumbers numbers) {
	printf("(%c, %d, %.2f)\n", numbers.c, numbers.n, numbers.d);
}

int main(void) {

	SomeNumbers numbers_1 = init_struct('a', 5, 1.5);
	SomeNumbers numbers_2 = { 'b', 2, 4.5 };
	SomeNumbers numbers_3 = init_any_order('c', 6, 5.2);

	printf("size = %zu\n", sizeof(SomeNumbers));
	printf("%p %p %p\n", &(numbers_1.c), &(numbers_1.n), &(numbers_1.d));
	print_numbers(numbers_1);
	print_numbers(numbers_2);
	print_numbers(numbers_3);

	return EXIT_SUCCESS;
}

