#include <stdio.h>
#include <stdlib.h>

int main (void) {
	union {
		unsigned char bytes[sizeof(double)];
		double value;
	} union_double = { .value = 6789.23 };

	union {
		unsigned char bytes[sizeof(float)];
		float value;
	} union_float = { .value = 6789.23f };

	union {
		unsigned char bytes[sizeof(int)];
		int value;
	} union_int = { .value = 4567 };

	printf("%f = ", union_double.value);
	for (size_t i = 0; i < sizeof(double); i++) {
		printf("%02x ", (int)union_double.bytes[i]);
	}
	printf("(hex)\n");

	printf("%f = ", union_float.value);
	for (size_t i = 0; i < sizeof(float); i++) {
		printf("%02x ", (int)union_float.bytes[i]);
	}
	printf("(hex)\n");

	printf("%d = %x (hex) = ", union_int.value, union_int.value);
	for (size_t i = 0; i < sizeof(int); i++) {
		printf("%02x ", (int)union_int.bytes[i]);
	}
	printf("(hex)\n");

	return EXIT_SUCCESS;
}

